// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "EndlessVendetta/EndlessVendettaCharacter.h"
#include "BountyHunterCharacter.generated.h"

/**
 * 
 */
UCLASS()
class ENDLESSVENDETTA_API ABountyHunterCharacter : public AEndlessVendettaCharacter
{
	GENERATED_BODY()
// ------------------- ATTRIBUTES ------------------------------

	// Array of Main Bounties' Classes in Order
	UPROPERTY(EditDefaultsOnly, Category = "Bounty Hunter")
	TArray<TSubclassOf<AMainBountyClass>> MainBountyClasses;
	
	// Reference to the Currently Active Main Bounty
	UPROPERTY(VisibleAnywhere, Category = "Bounty Hunter")
	AMainBountyClass* ActiveMainBounty;

	// Index of Currently Active Main Bounty, Used for MainBountyClasses
	int CurrentMainBountyIndex = 0;
	
protected:

	
public:
	

// ------------------- METHODS ---------------------------------
private:
	// Spawns Main Bounty from MainBountyClasses at the CurrentMainBountyIndex, along with its Side Bounties
	UFUNCTION(BlueprintCallable, Category = "Bounty Hunter")
	void SpawnBounties();
	
	// Checks if Player Completed Current Main Bounty, if so Collects Reward and Tries to Move onto Next Main Bounty
	UFUNCTION(BlueprintCallable, Category = "Bounty Hunter")
	void CompleteCurrentMainBounty();
	
protected:
	// Called When Player Spawns
	virtual void BeginPlay() override;

	// Called every frame
	virtual void Tick(float DeltaTime) override;
public:	
	
};
